git-merge-one-file.shon commit merge-one-file: use empty- or common-base condintionally in two-stage merge. (fd66dbf)
   1#!/bin/sh
   2#
   3# Copyright (c) Linus Torvalds, 2005
   4#
   5# This is the git per-file merge script, called with
   6#
   7#   $1 - original file SHA1 (or empty)
   8#   $2 - file in branch1 SHA1 (or empty)
   9#   $3 - file in branch2 SHA1 (or empty)
  10#   $4 - pathname in repository
  11#   $5 - orignal file mode (or empty)
  12#   $6 - file in branch1 mode (or empty)
  13#   $7 - file in branch2 mode (or empty)
  14#
  15# Handle some trivial cases.. The _really_ trivial cases have
  16# been handled already by git-read-tree, but that one doesn't
  17# do any merges that might change the tree layout.
  18
  19case "${1:-.}${2:-.}${3:-.}" in
  20#
  21# Deleted in both or deleted in one and unchanged in the other
  22#
  23"$1.." | "$1.$1" | "$1$1.")
  24        if [ "$2" ]; then
  25                echo "Removing $4"
  26        fi
  27        if test -f "$4"; then
  28                rm -f -- "$4"
  29        fi &&
  30                exec git-update-index --remove -- "$4"
  31        ;;
  32
  33#
  34# Added in one.
  35#
  36".$2." | "..$3" )
  37        echo "Adding $4"
  38        git-update-index --add --cacheinfo "$6$7" "$2$3" "$4" &&
  39                exec git-checkout-index -u -f -- "$4"
  40        ;;
  41
  42#
  43# Added in both, identically (check for same permissions).
  44#
  45".$3$2")
  46        if [ "$6" != "$7" ]; then
  47                echo "ERROR: File $4 added identically in both branches,"
  48                echo "ERROR: but permissions conflict $6->$7."
  49                exit 1
  50        fi
  51        echo "Adding $4"
  52        git-update-index --add --cacheinfo "$6" "$2" "$4" &&
  53                exec git-checkout-index -u -f -- "$4"
  54        ;;
  55
  56#
  57# Modified in both, but differently.
  58#
  59"$1$2$3" | ".$2$3")
  60        src2=`git-unpack-file $3`
  61        case "$1" in
  62        '')
  63                echo "Added $4 in both, but differently."
  64                # This extracts OUR file in $orig, and uses git-apply to
  65                # remove lines that are unique to ours.
  66                orig=`git-unpack-file $2`
  67                sz0=`wc -c <"$orig"`
  68                diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add 
  69                sz1=`wc -c <"$orig"`
  70
  71                # If we do not have enough common material, it is not
  72                # worth trying two-file merge using common subsections.
  73                expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
  74                ;;
  75        *)
  76                echo "Auto-merging $4."
  77                orig=`git-unpack-file $1`
  78                ;;
  79        esac
  80
  81        # We reset the index to the first branch, making
  82        # git-diff-file useful
  83        git-update-index --add --cacheinfo "$6" "$2" "$4"
  84                git-checkout-index -u -f -- "$4" &&
  85                merge "$4" "$orig" "$src2"
  86        ret=$?
  87        rm -f -- "$orig" "$src2"
  88
  89        if [ "$6" != "$7" ]; then
  90                echo "ERROR: Permissions conflict: $5->$6,$7."
  91                ret=1
  92        fi
  93        if [ "$1" = '' ]; then
  94                ret=1
  95        fi
  96
  97        if [ $ret -ne 0 ]; then
  98                echo "ERROR: Merge conflict in $4."
  99                exit 1
 100        fi
 101        exec git-update-index -- "$4"
 102        ;;
 103
 104*)
 105        echo "ERROR: $4: Not handling case $1 -> $2 -> $3"
 106        ;;
 107esac
 108exit 1